global iwish progaide basedir Home


set basedir [file dir $argv0]

if {$env(HOME) == "c:\\"} {
set Home $basedir
} else {
set Home [file join $env(HOME) leterrier kidistb]
}

switch $tcl_platform(platform) {
    unix {
	set progaide konqueror
	#set progaide dillo
	set iwish wish
	}
    windows {
	set progaide shellexec.exe
	set iwish wish
	}
	}


proc initapp {plateforme} {
global basedir Home
lappend auto_path $basedir
cd $basedir


if {![file exists [file join $Home]]} {
	file mkdir [file join $Home]
	file copy -force [file join images] [file join $Home]
	file copy -force [file join sons] [file join $Home]
	file copy -force [file join conte.kdb] [file join $Home]

}

}

proc loadlib {plateforme} {

global taillefont

switch $plateforme {

    unix {
if {[info tclversion] == "8.4"} {
    load [file join Img1.3 libimg1.2.so]
    load [file join lib kidistb2.so]
} else {
    load [file join Img1.2 libimg1.2.so]
    load [file join lib kidistb.so]
}
    set taillefont {1 10 16 22 29 40 50}
    }
    windows {
    package require Img
    load [file join lib kidi.dll]
    set taillefont {1 8 12 16 20 24 28}
    }
}

}
