#!/bin/sh
#kidistb.tcl
#Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}
############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  :
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version $Id: tool.tcl,v 1.1.1.1 2003/11/11 00:33:10 erics Exp $
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################

proc peuplelistpage {nbpage} {
global indexpage
.wcorner.wtool2.listpage delete 0 end
for {set x 1} {$x<=$nbpage} {incr x} {
.wcorner.wtool2.listpage insert end [format [mc {Page %1$s}] $x]
}
.wcorner.wtool2.listpage selection set $indexpage
.wcorner.wtool.labelpage configure -text [format [mc {Page %1$s}] [expr $indexpage +1]]
}

#######################################################################
frame .wcorner -background gray75 -width 20 -height 200
pack .wcorner -side left -anchor n -fill both
frame .wcorner.wtopcorner -width 60 -height 30 -background gray75
pack .wcorner.wtopcorner -side top -anchor n -fill both

#la barre d'outils
frame .wcorner.wtool -background gray75 -width 20 -height 100
pack .wcorner.wtool -side top -anchor n -fill both
button .wcorner.wtool.image -text [mc {Image}] -command "openimg $c image" -activebackground grey
button .wcorner.wtool.texte -text [mc {Texte}] -command "opentext $c" -activebackground grey
button .wcorner.wtool.forme -text [mc {Forme}] -command "openpoly $c" -activebackground grey
pack .wcorner.wtool.image .wcorner.wtool.texte .wcorner.wtool.forme -side top -anchor n -fill x


menubutton .wcorner.wtool.bouton -direction right -text [mc {Bouton}] -menu .wcorner.wtool.bouton.b1 -relief raised -activebackground grey
menu .wcorner.wtool.bouton.b1 -tearoff 0
.wcorner.wtool.bouton.b1 add command -label [mc {Page suivante}] -command "bouton1 $c 1"
.wcorner.wtool.bouton.b1 add command -label [mc {Page precedente}] -command "bouton1 $c 2"
.wcorner.wtool.bouton.b1 add command -label [mc {Page sommaire}] -command "bouton1 $c 3"
.wcorner.wtool.bouton.b1 add command -label [mc {Autre}] -command "openimg $c bouton2"
pack .wcorner.wtool.bouton -side top -anchor n -fill x

button .wcorner.wtool.obj -background gray75 -text [mc {Objet :}] -command "setnomobj $c"
pack .wcorner.wtool.obj -pady 10 -side top -fill x
label .wcorner.wtool.entobj -font {Helvetica 10} -width 3
pack .wcorner.wtool.entobj -side top -fill x



label .wcorner.wtool.labelholder -background gray75
pack .wcorner.wtool.labelholder -pady 10
label .wcorner.wtool.labelpage -text  [mc {Page 1}] -background gray75
pack .wcorner.wtool.labelpage -anchor s
button .wcorner.wtool.pageplus -text [mc {+}] -command "inserepage $c" -activebackground grey
#linux : enlever expand 1 et text - au lieu de --
button .wcorner.wtool.pagemoins -text [mc {--}] -command "deletepage $c" -activebackground grey
pack .wcorner.wtool.pageplus .wcorner.wtool.pagemoins -side left -pady 10 -expand 1

frame .wcorner.wtool2 -background gray75 -width 20 -height 50
pack .wcorner.wtool2 -side top -anchor n
#linux : width 6
listbox .wcorner.wtool2.listpage -yscrollcommand ".wcorner.wtool2.scrollpage set" -width 8 -height 6
scrollbar .wcorner.wtool2.scrollpage -command ".wcorner.wtool2.listpage yview" -width 7
pack .wcorner.wtool2.listpage .wcorner.wtool2.scrollpage -side left -fill y -expand 1
bind .wcorner.wtool2.listpage <ButtonRelease-1> "changelistpage $c %x %y"
peuplelistpage 1



####################################################################

proc creetool {itm c} {
global canvw canvh taillefont tabpage tid msound tabobj iwish progaide basedir
set ind [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
catch {destroy .waction}

frame .waction -background gray75 -width 100 -height 20
pack .waction -side top -anchor w -fill both
if {$itm=="canvas"} {

menubutton .waction.couleur_f -text [mc {Coul. fond}] -direction above -menu .waction.couleur_f.f1 -relief raised -activebackground grey
menu .waction.couleur_f.f1 -tearoff 0
	.waction.couleur_f.f1 add command -label [mc {Autre}] -background grey -activebackground gray75 -command "setcolor canvas $c"
	foreach coul {Black red4 DarkGreen NavyBlue gray75 Red Green Blue gray50 Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    	.waction.couleur_f.f1 add command -label "    " -background $coul -activebackground Black -command "$c configure -background $coul"
	}
	pack .waction.couleur_f -side left -fill y
	.wcorner.wtool.entobj configure -text "canvas"
	return
} else {
button .waction.charge -text [mc {Devant}] -command "devant $c" -activebackground grey
pack .waction.charge -side left -anchor w -fill y
button .waction.sauve -text [mc {Derriere}] -command "derriere $c" -activebackground grey
pack .waction.sauve -side left -anchor w -fill y
button .waction.sup -text [mc {Supprimer}] -command "delitem $c" -activebackground grey
pack .waction.sup -side left -anchor w -fill y
.wcorner.wtool.entobj configure -text $tabobj([lindex $tid($ind) end])
}

	switch $itm {
		typetext {
		set ftrans 0
		menubutton .waction.police -text [mc {Police}] -direction above -menu .waction.police.c1 -relief raised -activebackground grey
		menu .waction.police.c1 -tearoff 0
		.waction.police.c1 add command -label [mc {Helvetica}] -command "changepolice $c Helvetica"
		.waction.police.c1 add command -label [mc {Times}] -command "changepolice $c Times"
		.waction.police.c1 add command -label [mc {Courier}] -command "changepolice $c Courier"
		pack .waction.police -side left -fill y
		menubutton .waction.taille_p -text [mc {Taille}] -direction above -menu .waction.taille_p.c2 -relief raised -activebackground grey
		menu .waction.taille_p.c2 -tearoff 0
		foreach taille {1 2 3 4 5 6} {
		.waction.taille_p.c2 add command -label [mc $taille] -command "changetaille $c $taille"
		}
		pack .waction.taille_p -side left -fill y
		menubutton .waction.couleur_t -text [mc {Coul. texte}] -direction above -menu .waction.couleur_t.t1 -relief raised -activebackground grey
		menu .waction.couleur_t.t1 -tearoff 0
		.waction.couleur_t.t1 add command -label [mc {Autre}] -background grey -activebackground gray75 -command "setcolor coultext $c"
		foreach coul {Black red4 DarkGreen NavyBlue gray75 Red Green Blue gray50 Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_t.t1 add command -label "    " -background $coul -activebackground Black -command "$c itemconfigure cible -fill $coul"
		}
		pack .waction.couleur_t -side left -fill y

		menubutton .waction.couleur_f -text [mc {Coul. fond}] -direction above -menu .waction.couleur_f.f1 -relief raised -activebackground grey
		menu .waction.couleur_f.f1 -tearoff 0
		.waction.couleur_f.f1 add command -label [mc {Autre}] -background grey -activebackground gray75 -command "setcolor coulfond $c"
		foreach coul {Black red4 DarkGreen NavyBlue gray75 Red Green Blue gray50 Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_f.f1 add command -label "    " -background $coul -activebackground Black -command "changefond $c $coul"
		}
		pack .waction.couleur_f -side left -fill y


		menubutton .waction.couleur_tour -text [mc {Coul. tour}] -direction above -menu .waction.couleur_tour.tour -relief raised -activebackground grey
		menu .waction.couleur_tour.tour -tearoff 0
		.waction.couleur_tour.tour add command -label [mc {Autre}] -background grey -activebackground gray75 -command "setcolor coultour $c"
		foreach coul {Black red4 DarkGreen NavyBlue gray75 Red Green Blue gray50 Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_tour.tour add command -label "    " -background $coul -activebackground Black -command "changetrait $c $coul"
		}
		pack .waction.couleur_tour -side left -fill y
		checkbutton .waction.fond_trans -variable ftrans -text [mc {Transparent}] -activebackground grey -relief raised -command "fondtrans $c $ftrans"
		pack .waction.fond_trans -side left -fill y
		}
		typepolygon - typebouton1 {
                set ftrans2 0
		menubutton .waction.couleur_f -text [mc {Coul. fond}] -direction above -menu .waction.couleur_f.f1 -relief raised -activebackground grey
		menu .waction.couleur_f.f1 -tearoff 0
		.waction.couleur_f.f1 add command -label [mc {Autre}] -background grey -activebackground gray75 -command "setcolor coulfond1 $c"
		foreach coul {Black red4 DarkGreen NavyBlue gray75 Red Green Blue gray50 Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_f.f1 add command -label "    " -background $coul -activebackground Black -command "changefond1 $c $coul"
		}
		pack .waction.couleur_f -side left -fill y

		menubutton .waction.couleur_tour -text [mc {Coul. tour}] -direction above -menu .waction.couleur_tour.tour -relief raised -activebackground grey
		menu .waction.couleur_tour.tour -tearoff 0
		.waction.couleur_tour.tour add command -label [mc {Autre}] -background grey -activebackground gray75 -command "setcolor coultrait1 $c"
		foreach coul {Black red4 DarkGreen NavyBlue gray75 Red Green Blue gray50 Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_tour.tour add command -label "    " -background $coul -activebackground Black -command "changetrait1 $c $coul"
		}
		pack .waction.couleur_tour -side left -fill y
		checkbutton .waction.fond_trans -variable ftrans2 -text [mc {Transparent}] -activebackground grey -relief raised -command "fondtrans1 $c $ftrans2"
		pack .waction.fond_trans -side left -fill y
		}

		typebouton2 {
		menubutton .waction.couleur_fb -text [mc {Coul. texte}] -direction above -menu .waction.couleur_fb.f1 -relief raised -activebackground grey
		menu .waction.couleur_fb.f1 -tearoff 0
		.waction.couleur_fb.f1 add command -label [mc {Autre}] -background grey -activebackground gray75 -command "setcolor bouton2 $c"
		foreach coul {Black red4 DarkGreen NavyBlue gray75 Red Green Blue gray50 Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_fb.f1 add command -label "    " -background $coul -activebackground Black -command "changetextebouton2 $c $coul"
		}
		pack .waction.couleur_fb -side left -fill y
		

		label .waction.page -background gray75 -text [mc {Aller a la page : }]
		pack .waction.page -padx 10 -side left -fill y
		entry .waction.entpage -font {Helvetica 12} -width 5
		pack .waction.entpage -side left -fill y
		.waction.entpage insert end $tabpage($ind)
		#pour changer de pages, sur clic dans la liste
		bind .waction.entpage <KeyRelease> "settabpage $ind"
		}
	}
if {$msound ==1} {
button .waction.forme -text [mc {Son}] -command "opensound $c" -activebackground grey
pack .waction.forme -side left -anchor w
}
}


frame .wmenu -background #ffff80 -width 100 -height 20 -background gray75
pack .wmenu -side top -anchor w -fill both

############################## la barre de menus
    menubutton .wmenu.file -text [mc {Fichier}] -menu .wmenu.file.m -pady 7
    menubutton .wmenu.edit -text [mc {Edition}] -menu .wmenu.edit.m -pady 7
    menubutton .wmenu.action -text [mc {Action}] -menu .wmenu.action.m -pady 7
    menubutton .wmenu.aide -text [mc {?}] -menu .wmenu.aide.m -pady 7

    pack .wmenu.file -side left
    pack .wmenu.edit -side left
    pack .wmenu.action -side left
    pack .wmenu.aide -side left

#le menu fichier
    menu .wmenu.file.m -background gray80 -tearoff 0
    .wmenu.file.m add command -label [mc {Nouveau}] -command "nouveau $c"
    .wmenu.file.m add command -label [mc {Ouvrir}] -command "charge $c"
    .wmenu.file.m add command -label [mc {Enregistrer}] -command "sauve $c old"
    .wmenu.file.m add command -label [mc {Enregistrer sous}] -command "sauve $c new"
    if {$tcl_platform(platform)=="unix"} {
    .wmenu.file.m add command -label [mc {Imprimer}] -command "imprime $c"
    }
    .wmenu.file.m add separator
    .wmenu.file.m add command -label [mc {Quitter}] -command "destroy ."
   
#le menu d'dition
    menu .wmenu.edit.m -background gray80 -tearoff 0
    .wmenu.edit.m add command -label [mc {Copier la page}] -command "copiepage $c"
    .wmenu.edit.m add command -label [mc {Coller la page}] -command "collepage $c"
    menu .wmenu.action.m -background gray80 -tearoff 0
    .wmenu.action.m add command -label [mc {Jouer}] -command "joue $c 0"
    .wmenu.action.m add command -label [mc {Jouer Page}] -command "joue $c 1"

    .wmenu.action.m add command -label [mc {Diffuser}] -command "diffuse"
    .wmenu.action.m add command -label [mc {Programmer}] -command "openevent $c"


    menu .wmenu.aide.m -background gray80 -tearoff 0
    set fichier [string map {\\ /} [file join aide index.htm]]


    .wmenu.aide.m add command -label [mc {Aide}] -command "exec $progaide \042$fichier\042 &"


#############################################################################
proc changelistpage {c x y} {
set ind [.wcorner.wtool2.listpage index @$x,$y]
sauvepage $c $ind
affichenouvellepage $c
.wcorner.wtool.labelpage configure -text [format [mc {Page %1$s}] [expr $ind +1]]
}

proc inserepage {c} {
global indexpage totalpage listdata tid tabevent tabobj

set ind $indexpage

relink $c $ind up
#on ajoute la page dans la liste
set listdata [linsert $listdata [expr $ind + 1] {" "}]
#on recode les scripts de tabevent pour tenir compte du dcalage
	for {set i [expr $totalpage]} {$i > [expr $ind + 1] } {incr i -1} {
	set listdata [string map "{aller Page [expr $i]} {aller Page [expr $i + 1]}" $listdata]
	}
sauvepage $c [expr $ind + 1]
affichenouvellepage $c

set tabevent(canvas) {pageenter {} pageleave {}}
incr totalpage
peuplelistpage $totalpage
}

proc deletepage {c} {
global indexpage totalpage listdata tabobj tabevent
	if {$indexpage == 0 } {
	bell
	return}
	if {$totalpage > 1} {
	set ind $indexpage

	relink $c $ind down
	#on recode les scripts de tabevent pour tenir compte du dcalage, on remplace les entres de la page dtruite par page?
	set listdata [lreplace $listdata [expr $ind] [expr $ind]]
	set listdata [string map "{aller Page [expr $ind + 1]} {aller Page ?}" $listdata]

	for {set i [expr $ind + 2]} {$i <= $totalpage} {incr i 1} {
	set listdata [string map "{aller Page [expr $i]} {aller Page [expr $i -1]}" $listdata]
	}

	set totalpage [expr $totalpage - 1]
     		if {$indexpage > 0} {
     		set indexpage [expr $indexpage - 1]

			$c delete all
			foreach it [lindex $listdata $indexpage] {
			eval $it}
			
		}
		peuplelistpage $totalpage
	}
	

}

proc joue {c page} {
global nomf indexpage totalpage iwish
set nomf [lindex [lindex [split $nomf /] end] 0]
if {$nomf ==""} {
bell
tk_messageBox -message [mc {Veuillez enregistrer votre travail d'abord.}] -type ok
return
}
sauve $c old
if {$page ==0} {
exec $iwish jouer.tcl $nomf 0 &
}
if {($page==1) && ($indexpage < $totalpage)} {
exec $iwish jouer.tcl $nomf $indexpage &
}
}



proc bouton1 {c sens} {
global canvw canvh
switch $sens {
	1 {
	createbouton1 $c fleched.pol blue black pagesuiv new
	}
	2 {
	createbouton1 $c flecheg.pol blue black pageprec new
	}
	3 {
	createbouton1 $c sommaire.pol blue black sommaire new
	}
}
}

proc forme {c nom} {
      if {$nom !=""} {
	createpolygon $c $nom.pol Blue Black 0 new 
	}
}

proc settabpage {ind} {
global tabpage
set num [.waction.entpage get]
if {[string is integer $num] && ($num !="")} {
set tabpage($ind) $num
} 
 }

proc relink {c ind sens} {

global tabpage listdata tabevent
	foreach it [array names tabpage] {
	set temp1 "set tabpage($it) $tabpage($it)"
		switch $sens {
			down {
				if {$tabpage($it) > $ind} {
				set temp2 "set tabpage($it) [expr $tabpage($it) - 1]"
				set tabpage($it) [expr $tabpage($it) - 1]
				set listdata [string map "{$temp1} {$temp2}" $listdata]
				}
				if {$tabpage($it) == $ind} {
				#set temp2 "set tabpage($it) 1"
				#set tabpage($it) 1
				#set listdata [string map "{$temp1} {$temp2}" $listdata]
				}
			}
			up {
				if {$tabpage($it) > [expr $ind + 1]} {
				set temp2 "set tabpage($it) [expr $tabpage($it) + 1]"
				set tabpage($it) [expr $tabpage($it) + 1]
				set listdata [string map "{$temp1} {$temp2}" $listdata]
				}
			}
		}
	}
}

proc copiepage {c} {
#faudrait galement copier les scripts des pages
global tamponpage tid 
set tamponpage {}

foreach it [$c find all] {

if {[lsearch -regexp [$c gettags $it] uident*] !=-1} {
set ident [lindex [$c gettags $it] [lsearch -regexp [$c gettags $it] uident*]]
set typ [lindex [$c gettags $it] [lsearch -regexp [$c gettags $it] type*]]

set lbox [$c bbox $it]

    switch $typ {
        typetext {
	set arrfill [$c itemcget [expr [lindex $tid($ident) 0]] -fill]
	if {$arrfill ==""} {
	set arrfill \"\"
	}
	set arroutline [$c itemcget [expr [lindex $tid($ident) 0]] -outline]
	if {$arroutline ==""} {
	set arroutline \"\"
	}
	lappend tamponpage "createtexte \$c [expr [lindex $lbox 0] + int(([lindex $lbox 2] - [lindex $lbox 0])/2)] [lindex $lbox 1] \173[string map {\n \\n \" \040} [$c itemcget $it -text]]\175 $arrfill [$c itemcget $it -width] [$c itemcget $it -fill] [lindex [$c itemcget $it -font] 0] [lindex $tid($ident) 1] $arroutline new"

	}

	typebouton1 {
	set arrfill [$c itemcget $it -fill]
	if {$arrfill ==""} {
	set arrfill \"\"
	}
	if {[lsearch [$c gettags $it] pagesuiv] != -1} {
	lappend tamponpage "createbouton1 \$c \"[$c coords $it]\" $arrfill [$c itemcget $it -outline] pagesuiv renew"
	} elseif {[lsearch [$c gettags $it] pageprec] != -1} {
	lappend tamponpage "createbouton1 \$c \"[$c coords $it]\" $arrfill [$c itemcget $it -outline] pageprec renew"

	} elseif {[lsearch [$c gettags $it] sommaire] != -1} {
	lappend tamponpage "createbouton1 \$c \"[$c coords $it]\" $arrfill [$c itemcget $it -outline] sommaire renew"
	}
	}

	typepolygon {
	set arrfill [$c itemcget $it -fill]
	if {$arrfill ==""} {
	set arrfill \"\"
	}
	set sm [$c itemcget $it -smooth]
	if {$sm=="bezier"} {
	set sm 1
	} else {
	set sm 0}
	lappend tamponpage "createpolygon \$c \"[$c coords $it]\" $arrfill [$c itemcget $it -outline] $sm renew"
	}

	typeimage {
        lappend tamponpage "createimage \$c [lindex $tid($ident) 0] [expr [lindex $lbox 0]+ int(([lindex $lbox 2] - [lindex $lbox 0])/2)] [expr [lindex $lbox 1]+ int(([lindex $lbox 3] - [lindex $lbox 1])/2)] [lindex $tid($ident) 1] [lindex $tid($ident) 2] new"

	}
	typebouton2 {

	lappend tamponpage "createbouton2 \$c [lindex $tid($ident) 0] [expr [lindex $lbox 0]+ int(([lindex $lbox 2] - [lindex $lbox 0])/2)] [expr [lindex $lbox 1]+ int(([lindex $lbox 3] - [lindex $lbox 1])/2)] [lindex $tid($ident) 1] [lindex $tid($ident) 2] new \173[string map {\n \\n} [$c itemcget [lindex $tid($ident) 4] -text]]\175 \173[$c itemcget [lindex $tid($ident) 4] -font]\175 [$c itemcget [lindex $tid($ident) 4] -fill]"

	}

}
}

}
lappend tamponpage "\$c configure -background [$c cget -background]"
}




proc collepage {c} {
global tamponpage tid
foreach imag [image names] {
if {[string match "?imag*" $imag]} {
image delete $imag
}
}
$c delete all

foreach it $tamponpage {
eval $it
}

}


proc setcolor {type c} {
	global tid
    	set color [tk_chooseColor -title [mc {Choisir une couleur}]]

    if {$color != ""} {
	switch $type {
		canvas {$c configure -background $color}
		coultext {$c itemconfigure cible -fill $color}
		coulfond {changefond $c $color}
		coultour {changetrait $c $color}
		coulfond1 {changefond1 $c $color}
		coultrait1 {changetrait1 $c $color}
		bouton2 {changetextebouton2 $c $color}
	}
    }
}

proc diffuse {} {
global Home iwish
	
set types {    {{Fichiers kdb}            {.kdb}        }}
set ext .kdb
catch {set nom [tk_getOpenFile -filetypes $types -initialdir $Home]}
    if {$nom != ""} {
        if  {[string match -nocase *.kdb $nom]==0} {
        set nom $nomf$ext
        }

} else {

return
}
set dirnom [file rootname $nom]
catch {file delete -force [file join $Home $dirnom]}

file mkdir [file join $Home $dirnom]

set f [open [file join $dirnom go.bat] "w"]
#puts $f "start kidiplayer.tcl [file tail $nom]"
puts $f "start kidiplayer.tcl"

close $f

set f [open [file join $dirnom go.sh] "w"]
puts $f "#!/bin/sh"
puts $f "exec $iwish kidiplayer.tcl [file tail $nom]"
close $f
#on copie tout,  l'avenir, il faudrait slectionner uniquement les objets du rpojet
catch {file attributes [file join $dirnom go.sh] -permissions rwxrwxrwx}

	file copy -force [file join $Home $nom] [file join $Home $dirnom]
	file copy -force [file join libjpeg.so.62.0.0] [file join $Home $dirnom]
	file copy -force [file join libpng.so.2.1.0.8] [file join $Home $dirnom]
	file copy -force [file join libz.so.1.1.3] [file join $Home $dirnom]
	file copy -force [file join libtiff.so.3.5.5] [file join $Home $dirnom]
	file copy -force [file join kidiplayer.tcl] [file join $Home $dirnom]
	file copy -force [file join jouerutils.tcl] [file join $Home $dirnom]
	file copy -force [file join son.tcl] [file join $Home $dirnom]
	file copy -force [file join msg.tcl] [file join $Home $dirnom]
	file copy -force [file join Img1.3] [file join $Home $dirnom]
	file copy -force [file join Img1.2] [file join $Home $dirnom]
	file copy -force [file join $Home sons] [file join $Home $dirnom]
	file copy -force [file join $Home images] [file join $Home $dirnom]
	file copy -force [file join lib] [file join $Home $dirnom]
	file copy -force [file join polygon] [file join $Home $dirnom]
	file copy -force [file join msgs] [file join $Home $dirnom]

tk_messageBox -message [format [mc {Le projet a ete enregistre dans le repertoire %1$s. Sous windows, il demarre en cliquant sur le fichier go.bat. Sous Linux, tapez ./go.sh dans une console.}] $dirnom] -type ok

}

proc setnomobj {c} {
global tid tabobj
#return si nom = canvas
if {[.wcorner.wtool.entobj cget -text] == "canvas"} {
return
}
catch {destroy .nomobj}
toplevel .nomobj -background grey -width 250 -height 100
wm geometry .nomobj +50+50

frame .nomobj.frame -background grey -width 250 -height 100
pack .nomobj.frame -side top
label .nomobj.frame.labobj -font {Helvetica 10} -text "Nouveau nom :" -background grey
pack .nomobj.frame.labobj -side top 
entry .nomobj.frame.entobj -font {Helvetica 10} -width 10
pack .nomobj.frame.entobj -side top 
button .nomobj.frame.ok -background gray75 -text "Ok" -command "verifnomobj $c"
pack .nomobj.frame.ok -side top -pady 10

}

proc verifnomobj {c} {
global tabobj tabevent
set ind [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
foreach item [array names tabobj] {
if {[join [.nomobj.frame.entobj get] ""] == $tabobj($item)} {
tk_messageBox -message "Ce nom existe dj." -type ok -icon info 
catch {destroy .nomobj}
return
}
}
# on modifie tabevent pour prendre en compte le nouveau nom de l'objet
if {$ind !="" && $ind !=-1 && [join [.nomobj.frame.entobj get] ""] != "" } {
foreach item [array names tabevent] {
set tabevent($item) [string map "{$tabobj($ind)} {[join [.nomobj.frame.entobj get] ""]}" $tabevent($item)]
}
set tabobj($ind) [join [.nomobj.frame.entobj get] ""]
.wcorner.wtool.entobj configure -text $tabobj($ind)
}
catch {destroy .nomobj}
}
