#!/bin/sh
#choixpoly.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : choixpoly.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version $Id: choixpoly.tcl,v 1.1.1.1 2003/11/11 00:33:10 erics Exp $
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################


# Construction des widgets de l'interface, gnr automatiquement par tkbuilder
#. configure  -height 480 -width 64





#ouverture de la fentre pour la gestion des images
proc openpoly {c} {
	catch {destroy .wpoly}
      global CanvasGere
	set CanvasGere 0
	$c focus ""
	creetool canvas $c
	toplevel .wpoly -background #ffff80
	wm geometry .wpoly +70+110
	wm title .wpoly [mc {Choisir une forme}]
	wm transient .wpoly .
      canvas .wpoly.cpoly -width 320 -height 300
      pack .wpoly.cpoly
	set xpos 10
	set ypos 10
	set ext .pol
      foreach it {poly1 poly2 poly3 poly4 poly5 poly6} {
	set f [open [file join polygon $it$ext] "r"]
	set pol [gets $f]
	close $f
	set sm 1
	if {($it =="poly2") || ($it =="poly4") } {
	set sm 0}
	set tmp [.wpoly.cpoly create polygon $pol -fill blue -tags "choix $it" -outline black -smooth $sm]
	.wpoly.cpoly  move $tmp $xpos $ypos
      .wpoly.cpoly  bind $it <1> "forme $c $it; destroy .wpoly"
	set xpos [expr $xpos + 150]
      if {$xpos > 300} {
	set xpos 10
	set ypos [expr $ypos + 100]
	}

}
}
