#!/bin/sh
#Editeur.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  :
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################


# Construction des widgets de l'interface, gnr automatiquement par tkbuilder
#. configure  -height 480 -width 64


#ouverture de la fentre pour la gestion des images
proc openimg {c type} {

    global currentimg Home
    toplevel .w1 -background #ffff80

    wm title .w1 [mc {Choisir une image ou un bouton}]
    frame .w1.frame -background #ffff80 -width 250 -height 600
    pack .w1.frame -side left
     frame .w1.frame2 -background #ffff80 -width 250 -height 600  
    pack .w1.frame2 -side right
    listbox .w1.frame.list2 -yscrollcommand ".w1.frame.scroll2 set"
    scrollbar .w1.frame.scroll2 -command ".w1.frame.list2 yview"
    place .w1.frame.list2 -height 130 -width 130 -x 60 -y 50
    place .w1.frame.scroll2 -x 180 -y 50 -height 130
    label .w1.frame2.img -background #ff80c0
    pack .w1.frame2.img -anchor center
    button .w1.frame.ok -text [mc {Ok}] -command "setimage .w1 $c $type"
    place .w1.frame.ok -x 70 -y 400
    button .w1.frame.annul -text [mc {Annuler}] -command {destroy .w1}
    place .w1.frame.annul -x 130 -y 400
    listbox .w1.frame.list3 -yscrollcommand ".w1.frame.scroll3 set"
    scrollbar .w1.frame.scroll3 -command ".w1.frame.list3 yview"

    label .w1.frame.labl4 -text [mc {Dont le nom contient les lettres}] -background #ffff80
    place .w1.frame.labl4 -x 40 -y 260
    label .w1.frame.labl5 -text [mc {(Entree pour valider.}]  -background #ffff80
    place .w1.frame.labl5 -x 70 -y 300
    label .w1.frame.labl6 -text [mc {Laissez le champ vide}] -background #ffff80
    place .w1.frame.labl6 -x 65 -y 320
    label .w1.frame.labl7 -text [mc {pour afficher toutes les images)}] -background #ffff80
    place .w1.frame.labl7 -x 55 -y 340

    entry .w1.frame.recherche
    place .w1.frame.recherche -x 60 -y 280



    peuplelist2

    catch {
    image create photo imagetmp -file [file join $Home images [.w1.frame.list2 get 0]]
    .w1.frame2.img configure -image imagetmp
    }

    bind .w1 <Control-q> {destroy .w1}
    bind .w1.frame.list2 <ButtonRelease-1> "changeimage %x %y"
    bind .w1.frame.list3 <ButtonRelease-1> "changelist2 %x %y"
    bind .w1.frame.recherche <Return> "changelist3"

}
#######################################################
proc changelist3 {} {
global Home
set ext .gif
set ext2 .ppm
set ext3 .jpg
set ext4 .png
set jok *
set currenttext [.w1.frame.recherche get]
  if {$currenttext !=""} {
    .w1.frame.list2 delete 0 end
      catch {
    image create photo imagetmp -file [file join $Home images blank.gif]
    .w1.frame2.img configure -image imagetmp

      foreach i [lsort [glob [file join $Home images $jok$currenttext$jok$ext] [file join $Home images $jok$currenttext$jok$ext2] [file join $Home images $jok$currenttext$jok$ext3] [file join $Home images $jok$currenttext$jok$ext4]]] {
      #foreach i [lsort [glob [file join $Home images $jok$currenttext$jok$ext] [file join $Home images $jok$currenttext$jok$ext2]]] 

      .w1.frame.list2 insert end [file tail $i]
      } }
      } else {
peuplelist2
}
}

proc changeimage {x y} {
    global Home
    set curimg [.w1.frame.list2 get @$x,$y]
    catch {
    image create photo imagetmp -file [file join $Home images $curimg]
    .w1.frame2.img configure -image imagetmp
    }
}






proc peuplelist2 {} {
   global Home
   .w1.frame.list2 delete 0 end
   set ext .gif
   set ext2 .ppm
   set ext3 .jpg
   set ext4 .png


   catch {foreach i [lsort [glob [file join $Home images *$ext] [file join $Home images *$ext2] [file join $Home images *$ext3] [file join $Home images *$ext4]]] {
   #catch foreach i [lsort [glob [file join $Home images *$ext] [file join $Home images *$ext2]]] 

     .w1.frame.list2 insert end [file tail $i]
     }
   }
}









proc setimage {wind c type} {
global canvw canvh taillefont
set currentimg [$wind.frame.list2 get active]
if {$currentimg !="blank.gif"} {
switch $type {
	image {
	createimage $c $currentimg [expr int($canvw/2)] [expr int($canvh/2)] 1 1 new
	#creetool none $c
	}
	bouton2 {
	createbouton2 $c $currentimg [expr int($canvw/2)] [expr int($canvh/2)] 1 1 new Bouton "Helvetica [lindex $taillefont 2] bold" Black
	}
	}
}
destroy $wind
}