proc getid {} {
global indexlibre
incr indexlibre
set idt uident$indexlibre
return $idt
}


proc getimgid {} {
global imgid
incr imgid
set idt kimage$imgid
return $idt
}

proc enterbouton {c tag} {
$c configure -cursor hand1
}

proc leavebouton {c tag} {
$c configure -cursor left_ptr
}

proc updownbutton {c type} {
global tid
set ident [lindex [$c gettags current] [lsearch -regexp [$c gettags current] uident*]]
if {$ident !="" && $ident != -1} {
	if {$type =="down"} {
		$c move [lindex $tid($ident) 4] [expr [lindex [$c bbox $tid($ident)] 0] + 1] [expr [lindex [$c bbox $tid($ident)] 1] + 1]
		update
	} else {
		$c move [lindex $tid($ident) 4] [expr [lindex [$c bbox $tid($ident)] 0] - 1] [expr [lindex [$c bbox $tid($ident)] 1] - 1]

	}
}
}


proc changepage {c sens type} {
global indexpage totalpage listdata tid tabpage tabson msound tabobj tabevent
#leavepage

if {$type == "seq"} {
	switch $sens {
		1 {
		if {$indexpage < [expr $totalpage - 1]} {
			set indexpage [expr $indexpage + 1]
			} 		
		}
		2 {
		if {$indexpage > 0} {
			set indexpage [expr $indexpage - 1]
			} 	
		}
		3 {
		set indexpage 0
		}
	}
} else {
	if {$sens <$totalpage} {
		if {$indexpage == $sens } {
			updownbutton $c up
			return
			}
		set indexpage $sens
		updownbutton $c up
	} else {
	bell
	}
}

initialise $c
affichepage $c
initpage
}

 
proc initialise {c} {
global listdata tabson tabobj tabevent
$c delete all
foreach imag [image names] {
	if {[string match "?imag*" $imag]} {
		image delete $imag
	}
}
catch {unset tabobj}
catch {unset tabevent}
set tabevent(canvas) {pageenter {} pageleave {}}
}

proc affichepage {c} {
global tid indexpage totalpage listdata nomf indexlibre tabpage tabson Home tabobj tabevent msound
foreach it [lindex $listdata $indexpage] {
eval $it
}
eval [lindex $listdata end]
$c configure -cursor left_ptr
##############################################
foreach item [array names tabobj] {
	$c addtag $tabobj($item) withtag $item
	}
foreach idt [array names tabevent] {
	if {$idt != "canvas"} {
		array set tabtmp $tabevent($idt) 
		foreach evt [array names tabtmp] {
			set msgerror "tk_messageBox -message \"Erreur dans le script :\\n[string map "returnx \\n" $tabtmp($evt) ]\" -type ok"
			set str "if \{\[catch \{[string map "returnx \\n" $tabtmp($evt) ]\}\]\} \{$msgerror\}"

			switch $evt {
				enter {
				$c bind $idt <Any-Enter> $str
				}

				leave {
				$c bind $idt <Any-Leave> $str
				}

				click {
					if {[lsearch [$c gettags $idt] typebouton2] !=-1  } {
					$c bind [lindex $tid($idt) 4] <1> $str
					}
					if {[lsearch [$c gettags $idt] typetext] !=-1  } {
					$c bind [lindex $tid($idt) 0] <1> $str
					}

					$c bind $idt <1> $str
					}
			}
		}
	}
}
$c focus ""

foreach it [array names tabpage] {
$c bind $it <ButtonRelease-1> "changepage $c [expr $tabpage($it) -1] random"
if {[lsearch [$c gettags $it] typebouton2] !=-1  } {
$c bind [lindex $tid($it) 4] <ButtonRelease-1> "changepage $c [expr $tabpage($it) -1] random"
}
#if {[lsearch [$c gettags $it] typetext] !=-1  } {
#$c bind [lindex $tid($it) 0] <ButtonRelease-1> "changepage $c [expr $tabpage($it) -1] random"
#}
}
if {$msound == 1} {
	foreach it [array names tabson] {
		$c bind $it <Any-Enter> "soundEnter $c $tabson($it)"
		$c bind $it <Any-Leave> "soundLeave $c"
		}
	}
$c itemconfigure pagesuiv -activewidth 3
$c itemconfigure pageprec -activewidth 3
$c itemconfigure sommaire -activewidth 3

}

proc charge {c} {
global tid indexpage totalpage listdata nomf indexlibre tabpage tabson Home tabobj tabevent
ouvreprojet
initialise $c
set f [open [file join $Home $nomf] "r"]
set listdata [gets $f]
close $f
set totalpage [expr [llength $listdata] -1]
affichepage $c
}

#######################################################""
proc createbouton1 {c fichier arrfill outcoul tag identif} {
global tid canvw canvh tabobj

$c dtag cible
catch {$c delete enveloppe}
if {$identif == "new"} {
set id [getid]
set f [open [file join polygon $fichier] "r"]
set it [gets $f]
close $f
} else {
set id $identif
set it $fichier
}
$c create polygon $it -fill $arrfill -tags "drag $id cible $tag typebouton1" -outline $outcoul

if {$identif == "new"} {
set x [expr int($canvw/2) - ([lindex [$c bbox cible] 2] - [lindex [$c bbox cible] 0])]
set y [expr int($canvh/2) - ([lindex [$c bbox cible] 3] - [lindex [$c bbox cible] 1])]
$c move cible $x $y
}
set tid($id) "\173$fichier\175"
#set tabson($id) ""
#createenveloppe $c cible
}

#############################################################################################""
proc createbouton2 {c fichier x y zoom1 zoom2 identif texte police coul} {
   global tid tabpage Home tabobj
   set bimage [getimgid]
$c dtag cible
catch {$c delete enveloppe}
   image create photo $bimage -file [file join $Home images $fichier]

  CZoom $bimage $zoom1 $zoom2
if {$identif == "new"} {
   set id [getid]
   set tabpage($id) 1
} else {
set id $identif
}
$c create image $x $y -image $bimage -tags "drag $id cible typebouton2"
set idtmp [$c create text $x $y -text [join $texte] -width 300 -anchor c -font $police -justify center -tags textbouton2 -fill $coul]

set tid($id) "\173$fichier\175 $zoom1 $zoom2 $bimage $idtmp $id"
#set tabson($id) ""
#createenveloppe $c cible

}

proc zoomebouton1 {c id imgcor psens cote x} {
global tid startx lcord Home
   set fichier [lindex $tid($id) 0]
   set zoom1 [lindex $tid($id) 1]
   set zoom2 [lindex $tid($id) 2]
   set bimage [lindex $tid($id) 3]
   set idtext [lindex $tid($id) 4]
   set orgid  [lindex $tid($id) 5]

set cimage [getimgid]
image create photo $cimage -file [file join $Home images $fichier]
set fact [expr ([lindex $lcord 2] - [lindex $lcord 0])/([lindex $imgcor 2] - [lindex $imgcor 0])]


set zoom1 [expr $zoom1*$fact]
set tid($id) "\173$fichier\175 $zoom1 $zoom2 $bimage $idtext $orgid"


CZoom $cimage $zoom1 $zoom2
$c itemconfigure $id -image $cimage
set xpos [expr $x  + $psens*(int(([lindex $lcord 2] - [lindex $lcord 0])/2)+3 )]
set ypos [expr [lindex $lcord 1] + int(([lindex $imgcor 3] - [lindex $imgcor 1])/2)+3 ]
$c coords $id $xpos $ypos
catch {image delete $bimage}
#redessineenveloppe $c $id
}


proc zoomebouton2 {c id imgcor psens cote y} {
global tid startx lcord Home
   set fichier [lindex $tid($id) 0]
   set zoom1 [lindex $tid($id) 1]
   set zoom2 [lindex $tid($id) 2]
  set bimage [lindex $tid($id) 3]
  set idtext [lindex $tid($id) 4]
   set orgid  [lindex $tid($id) 5]

set cimage [getimgid]
image create photo $cimage -file [file join $Home images $fichier]
set fact [expr ([lindex $lcord 3] - [lindex $lcord 1])/([lindex $imgcor 3] - [lindex $imgcor 1])]


set zoom2 [expr $zoom2*$fact]
set tid($id) "\173$fichier\175 $zoom1 $zoom2 $bimage $idtext $id"

CZoom $cimage $zoom1 $zoom2

$c itemconfigure $id -image $cimage

set xpos [expr [lindex $lcord 0] + int(([lindex $imgcor 2] - [lindex $imgcor 0])/2)+3 ]
set ypos [expr $y  + $psens*(int(([lindex $lcord 3] - [lindex $lcord 1])/2)+3 )]

$c coords $id $xpos $ypos
 catch {image delete $bimage}
#redessineenveloppe $c $id
}


#####################################################################

proc zoome1 {c id imgcor psens cote x} {
global tid startx lcord Home
   set fichier [lindex $tid($id) 0]
   set zoom1 [lindex $tid($id) 1]
   set zoom2 [lindex $tid($id) 2]
  set bimage [lindex $tid($id) 3]
  set id [lindex $tid($id) 4]

################################""
set cimage [getimgid]
image create photo $cimage -file [file join $Home images $fichier]
############################################
set fact [expr ([lindex $lcord 2] - [lindex $lcord 0])/([lindex $imgcor 2] - [lindex $imgcor 0])]


set zoom1 [expr $zoom1*$fact]
set tid($id) "\173$fichier\175 $zoom1 $zoom2 $bimage $id"


CZoom $cimage $zoom1 $zoom2

$c itemconfigure $id -image $cimage
set xpos [expr $x  + $psens*(int(([lindex $lcord 2] - [lindex $lcord 0])/2)+3 )]
set ypos [expr [lindex $lcord 1] + int(([lindex $imgcor 3] - [lindex $imgcor 1])/2)+3 ]
$c coords $id $xpos $ypos
 catch {image delete $bimage}
#redessineenveloppe $c $id
}


proc zoome2 {c id imgcor psens cote y} {
global tid startx lcord Home
   set fichier [lindex $tid($id) 0]
   set zoom1 [lindex $tid($id) 1]
   set zoom2 [lindex $tid($id) 2]
  set bimage [lindex $tid($id) 3]
  set id [lindex $tid($id) 4]


set cimage [getimgid]
image create photo $cimage -file [file join $Home images $fichier]
set fact [expr ([lindex $lcord 3] - [lindex $lcord 1])/([lindex $imgcor 3] - [lindex $imgcor 1])]


set zoom2 [expr $zoom2*$fact]
set tid($id) "\173$fichier\175 $zoom1 $zoom2 $bimage $id"


CZoom $cimage $zoom1 $zoom2

$c itemconfigure $id -image $cimage

set xpos [expr [lindex $lcord 0] + int(([lindex $imgcor 2] - [lindex $imgcor 0])/2)+3 ]
set ypos [expr $y  + $psens*(int(([lindex $lcord 3] - [lindex $lcord 1])/2)+3 )]

$c coords $id $xpos $ypos
 catch {image delete $bimage}
#redessineenveloppe $c $id
}


#############################################################################################""
proc createimage {c fichier x y zoom1 zoom2 identif} {
   global tid Home tabobj
   set bimage [getimgid]
$c dtag cible
   image create photo $bimage -file [file join $Home images $fichier]

  CZoom $bimage $zoom1 $zoom2
if {$identif == "new"} {
   set id [getid]
} else {
set id $identif
}
   $c create image $x $y -image $bimage -tags "drag $id cible typeimage"
   set tid($id) "\173$fichier\175 $zoom1 $zoom2 $bimage"
#set tabson($id) ""
#createenveloppe $c cible
}

#####################################################################

proc zoomepolygon1 {c id imgcor psens cote x} {
global tid startx lcord
set fact [expr ([lindex $lcord 2] - [lindex $lcord 0])/([lindex $imgcor 2] - [lindex $imgcor 0])]

$c scale $id [lindex [$c bbox $id] 0] [lindex [$c bbox $id] 1] $fact 1
$c move $id [expr $x -[lindex $imgcor 0] - $cote*([lindex $lcord 2] - [lindex $lcord 0])] 0
#redessineenveloppe $c $id
}


proc zoomepolygon2 {c id imgcor psens cote y} {
global tid startx lcord
set fact [expr ([lindex $lcord 3] - [lindex $lcord 1])/([lindex $imgcor 3] - [lindex $imgcor 1])]
$c scale $id [lindex [$c bbox $id] 0] [lindex [$c bbox $id] 1] 1 $fact

$c move $id 0 [expr $y -[lindex $imgcor 1] - $cote*([lindex $lcord 3] - [lindex $lcord 1])]

#redessineenveloppe $c $id
}


#############################################################################################""
proc createpolygon {c fichier arrcoul linecoul smoth identif} {

global tid canvw canvh tabobj

$c dtag cible
catch {$c delete enveloppe}

if {$identif == "new"} {
set id [getid]
set f [open [file join polygon $fichier] "r"]
set it [gets $f]
close $f
set sm 1
if {$fichier =="poly2.pol"} {
set sm 0}

} else {
set id $identif
set it $fichier
set sm $smoth
}
$c create polygon $it -fill $arrcoul -tags "drag $id cible typepolygon" -outline $linecoul -smooth $sm

if {$identif == "new"} {
set x [expr int($canvw/2) - ([lindex [$c bbox cible] 2] - [lindex [$c bbox cible] 0])]
set y [expr int($canvh/2) - ([lindex [$c bbox cible] 3] - [lindex [$c bbox cible] 1])]
$c move cible $x $y
}
set tid($id) "\173$fichier\175"
#set tabson($id) ""
#createenveloppe $c cible
}


proc createtexte {c x y texte couleur largeur fillcouleur police taillepol trait identif} {
   global tid taillefont tabobj
if {$identif =="new"} {
   set id [getid]
} else {
set id $identif
}

   set idtmp2 [$c create rect 0 0 0 0 -fill $couleur -state normal -outline $trait]
   set idtmp1 [$c create text $x $y -text [join $texte] -width $largeur -anchor n -font "$police [lindex $taillefont $taillepol]" -justify left -fill $fillcouleur -tags "drag $id typetext cible" ]
   $c coords $idtmp2 [$c bbox $idtmp1]
   $c lower $idtmp2 $idtmp1


   set tid($id) "$idtmp2 $taillepol $id"
#set tabson($id) ""

}

#############################################################"
proc initpage {} {
global tabevent

set script [lindex $tabevent(canvas) 1]

if {[catch {eval [string map "returnx \\n" $script ] } ]} {
tk_messageBox -message "Erreur dans le script :\n [string map "returnx \\n" $script ]" -type ok
}

}

proc leavepage {} {
global tabevent
set script [lindex $tabevent(canvas) 3]
if {[catch {eval [string map "returnx \\n" $script ] } ]} {
tk_messageBox -message "Erreur dans le script :\n [string map "returnx \\n" $script ]" -type ok
}
#eval [lindex $tabevent(canvas) 3]
}


proc affiche {idt} {
global tid
set id [lindex [.frame.c gettags $idt] [lsearch -regexp [.frame.c gettags $idt] uident*]]
set typ [lindex [.frame.c gettags $idt] [lsearch -regexp [.frame.c gettags $idt] type*]]
switch $typ {
	typetext {
	.frame.c itemconfigure [lindex $tid($id) 0] -state normal
	.frame.c itemconfigure $idt -state normal
	}
	typebouton2 {
	.frame.c itemconfigure [lindex $tid($id) 0] -state normal
	.frame.c itemconfigure $idt -state normal
	}
	default {
	.frame.c itemconfigure $idt -state normal
	}
}
}

proc cache {idt} {
global tid
set id [lindex [.frame.c gettags $idt] [lsearch -regexp [.frame.c gettags $idt] uident*]]
set typ [lindex [.frame.c gettags $idt] [lsearch -regexp [.frame.c gettags $idt] type*]]
switch $typ {
	typetext {
	.frame.c itemconfigure $idt -state hidden
	.frame.c itemconfigure [lindex $tid($id) 0] -state hidden
	}
	typebouton2 {
	.frame.c itemconfigure $idt -state hidden
	.frame.c itemconfigure [lindex $tid($id) 0] -state hidden
	}
	default {
	.frame.c itemconfigure $idt -state hidden
	}
}
}

proc jouerson {idt} {
global Home msound

if {$msound == 1 } {
catch {
	s stop
	update
	#s configure -file [file join $Home sons $idt]
	s read [file join $Home sons $idt]

	s play
	}
	}
}

proc aller {idt num} {
changepage .frame.c [expr $num - 1] random"

}

proc curseur {idt} {
switch $idt {
main {
.frame.c configure -cursor hand1
}
normal {
.frame.c configure -cursor left_ptr
}
}
}

proc deplace {idt x y compte vitesse } {
global tid
set id [lindex [.frame.c gettags $idt] [lsearch -regexp [.frame.c gettags $idt] uident*]]
set typ [lindex [.frame.c gettags $idt] [lsearch -regexp [.frame.c gettags $idt] type*]]

for {set i 0} {$i < $compte} {incr i 1} {
switch $typ {
	typetext {
	.frame.c move $idt $x $y
	.frame.c move [lindex $tid($id) 0] $x $y
	}
	typebouton2 {
	.frame.c move $idt $x $y
	.frame.c move [lindex $tid($id) 4] $x $y
	}
	default {
	.frame.c move $idt $x $y
	}
}
update
after $vitesse
}
}
