#!/bin/sh
#kidistb.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

global id tid imgid canvw canvh tool indexpage totalpage listdata nomf taillefont indexlibre tabpage tabson Home tabobj tabevent


set basedir [file dir $argv0]
lappend auto_path $basedir
cd $basedir

set Home $basedir

#package require Img
#set nomf [lindex $argv 0]

switch $tcl_platform(platform) {
    unix {
	set nomf [lindex $argv 0]
	if {[info tclversion] == "8.4"} {
	load [file join Img1.3 libimg1.2.so]
    	load [file join lib kidistb2.so]
	} else {
	load [file join Img1.2 libimg1.2.so]
    	load [file join lib kidistb.so]
	}
	set taillefont {1 10 16 22 29 40 50}
    }
    windows {
	package require Img
	set ext .kdb
	set nomf [file tail [string trim [string map {kidiplayer.tcl \040} $argv0]]]$ext
	load [file join lib kidi.dll]
	set taillefont {1 8 12 16 20 24 28}
    }
}

# see tkbuild for other messages
#wm overrideredirect . 1
###########################################################
proc ouvreprojet {} {
global tid indexpage totalpage listdata indexlibre
set listdata {{} {set indexlibre $indexlibre}}
set indexpage 0
set totalpage 1
set indexlibre 0
}

#################################################################

. configure -background #ffff80
source jouerutils.tcl
source son.tcl
source msg.tcl

set c .frame.c

set imgid 0
set id 0
set c .frame.c
set bgn #ffff80
set bgl #ff80c0
set font2 ""
set son 1
set tool 0
set totalpage 1
#set indexpage 0
set indexlibre 0
set canvw [expr [winfo screenwidth .] -100]
set canvh [expr [winfo screenheight .] -100]
set canvw 700
set canvh 500
frame .frame -width $canvw -height $canvh -background gray75
pack .frame -side top -fill both -expand yes



wm geometry . +0+0
canvas $c -width $canvw -height $canvh -background #ffff80 -highlightbackground #ffff80 -selectbackground green -selectborderwidth 4
pack $c


#################################################
 


charge $c


$c bind typebouton2 <Any-Enter> "enterbouton $c neutre"
$c bind typebouton2 <Any-Leave> "leavebouton $c neutre"
$c bind typebouton2 <ButtonPress-1> "updownbutton $c down"

$c bind pagesuiv <Any-Enter> "enterbouton $c pagesuiv"
$c bind pagesuiv <Any-Leave> "leavebouton $c pagesuiv"
$c bind pageprec <Any-Enter> "enterbouton $c pageprec"
$c bind pageprec <Any-Leave> "leavebouton $c pageprec"
$c bind sommaire <Any-Enter> "enterbouton $c sommaire"
$c bind sommaire <Any-Leave> "leavebouton $c sommaire"

$c bind pagesuiv <1> "changepage $c 1 seq"
$c bind pageprec <1> "changepage $c 2 seq"
$c bind sommaire <1> "changepage $c 3 seq"

initpage



